package org.drools.cep;

import org.drools.modelcompiler.dsl.pattern.D;
import org.drools.model.Index.ConstraintType;
import org.kie.hacep.sample.kjar.StockTickEvent;
import java.util.UUID;
import org.kie.remote.DroolsExecutor;
import org.kie.hacep.sample.kjar.Result;
import static org.drools.cep.Rules77ACC932F81F21CF780A1D7CF0EA54B0.*;

public class Rules77ACC932F81F21CF780A1D7CF0EA54B0RuleMethods0 {

    /**
     * Rule name: StockAverage
     */
    public static org.drools.model.Rule rule_StockAverage() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.Result> var_$r = D.declarationOf(org.kie.hacep.sample.kjar.Result.class,
                                                                                                   DomainClassesMetadata77ACC932F81F21CF780A1D7CF0EA54B0.org_kie_hacep_sample_kjar_Result_Metadata_INSTANCE,
                                                                                                   "$r");
        final org.drools.model.Variable<java.lang.String> var_$name = D.declarationOf(java.lang.String.class,
                                                                                      DomainClassesMetadata77ACC932F81F21CF780A1D7CF0EA54B0.java_lang_String_Metadata_INSTANCE,
                                                                                      "$name");
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_GENERATED_$pattern_StockTickEvent$1$ = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                                                             DomainClassesMetadata77ACC932F81F21CF780A1D7CF0EA54B0.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                                                             "GENERATED_$pattern_StockTickEvent$1$");
        final org.drools.model.Variable<Double> var_$p = D.declarationOf(Double.class,
                                                                         "$p");
        final org.drools.model.Variable<java.lang.Double> var_$avg = D.declarationOf(java.lang.Double.class,
                                                                                     DomainClassesMetadata77ACC932F81F21CF780A1D7CF0EA54B0.java_lang_Double_Metadata_INSTANCE,
                                                                                     "$avg");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockAverage").build(D.pattern(var_$r).bind(var_$name,
                                                                                         org.drools.cep.P92.LambdaExtractor927321FAF004B1197830350C060A22EA.INSTANCE,
                                                                                         D.reactOn("stockName")),
                                                                  D.accumulate(D.pattern(var_GENERATED_$pattern_StockTickEvent$1$).expr("E44016C0D11BC5C44AC48D88E9FD4D6A",
                                                                                                                                        var_$name,
                                                                                                                                        org.drools.cep.PFD.LambdaPredicateFD7882A79F7F2E931E867B81CD361D77.INSTANCE,
                                                                                                                                        D.betaIndexedBy(java.lang.String.class,
                                                                                                                                                        org.drools.model.Index.ConstraintType.EQUAL,
                                                                                                                                                        DomainClassesMetadata77ACC932F81F21CF780A1D7CF0EA54B0.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE.getPropertyIndex("company"),
                                                                                                                                                        org.drools.cep.PC3.LambdaExtractorC3CF686CF692CF4DB026148541F9B646.INSTANCE,
                                                                                                                                                        org.drools.cep.P19.LambdaExtractor193C6FD536F7981A9D6470F9F734A136.INSTANCE),
                                                                                                                                        D.reactOn("company")).bind(var_$p,
                                                                                                                                                                   org.drools.cep.P46.LambdaExtractor461BF168F73438671830254F14CEF1D5.INSTANCE,
                                                                                                                                                                   D.reactOn("price")),
                                                                               D.accFunction(org.drools.core.base.accumulators.AverageAccumulateFunction::new,
                                                                                             var_$p).as(var_$avg)),
                                                                  D.on(var_$name,
                                                                       var_$r,
                                                                       var_$avg).execute(org.drools.cep.P6C.LambdaConsequence6C0716FDBACBD405259231697C755AC5.INSTANCE));
        return rule;
    }

    /**
     * Rule name: StockLog
     */
    public static org.drools.model.Rule rule_StockLog() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_$stock = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                               DomainClassesMetadata77ACC932F81F21CF780A1D7CF0EA54B0.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                               "$stock");
        org.drools.model.Rule rule = D.rule("org.drools.cep",
                                            "StockLog").build(D.pattern(var_$stock),
                                                              D.on(var_$stock).execute(org.drools.cep.P0E.LambdaConsequence0EA6D1E0BC8F0DAFC7A18F287EE2A503.INSTANCE));
        return rule;
    }
}
